[![status](https://travis-ci.org/wearefractal/captchagen.png?branch=master)](https://travis-ci.org/wearefractal/captchagen)

## Information

<table>
<tr> 
<td>Package</td><td>captchagen</td>
</tr>
<tr>
<td>Description</td>
<td>Captcha image generator</td>
</tr>
<tr>
<td>Node Version</td>
<td>>= 0.6</td>
</tr>
</table>

![example](https://i.cloudup.com/j5gB0Piif2-3000x3000.png)

## Dependencies

This relies on a native module called node-canvas. You will need to install cairo, so read https://github.com/learnboost/node-canvas/wiki before installing.

## Usage

```javascript
var captchagen = require('captchagen');

// optional object arg with keys: height, width, text, font
var captcha = captchagen.create();

captcha.text();     // Returns captcha text (randomly generated by default)
captcha.height();   // Returns captcha height (150 by default)
captcha.width();    // Returns captcha width (300 by default)
captcha.generate(); // Draws the image to the canvas

/* call `generate()` before running the below */

captcha.uri(cb);      // outputs png data-uri. works sync and async (cb is optional)
captcha.buffer(cb);   // outputs png buffer. works sync and async (cb is optional)
captcha.buffer(type); // outputs an image stream. type can be either png or jpeg (png is the default)
```

## Middleware

The whole thing is a middleware stack. When you use .create() it uses our default settings which look like this:

```javascript
captcha.use(drawBackground);
captcha.use(drawLines);
captcha.use(drawText);
captcha.use(drawLines);
```

To add your own look at the middle folder in lib. You take a canvas in, modify it, and output it again. Simple stuff.


## LICENSE

(MIT License)

Copyright (c) 2012 Fractal <contact@wearefractal.com>

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

[![Bitdeli Badge](https://d2weczhvl823v0.cloudfront.net/wearefractal/captchagen/trend.png)](https://bitdeli.com/free "Bitdeli Badge")

